# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section     free
%define repo_dir    m2_repo/repository

Name:           xbean
Version:        2.3
Release:        1jpp
Epoch:          0
Summary:        XBean plugin based server
License:        Apache Software License 2.0
Group:          Development/Java
Vendor:         JPackage Project
Distribution:   JPackage
URL:            http://geronimo.apache.org/xbean
Source0:        xbean-2.3-src.tar.gz
# svn export http://svn.apache.org/repos/asf/geronimo/xbean/tags/xbean-2.3/

Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-settings.xml
Source4:        apache-3.pom
Patch0:		xbean-pom_xml.patch
Patch1:		xbean-reflect-pom_xml.patch
Patch2:		xbean-server-pom_xml.patch
Patch3:		xbean-maven-xbean-plugin-pom_xml.patch
Patch4:		xbean-classpath-pom_xml.patch
Patch5:		xbean-jmx-pom_xml.patch
Patch6:		xbean-kernel-pom_xml.patch
Patch7:		xbean-osgi-pom_xml.patch
Patch8:		xbean-sca-pom_xml.patch
Patch9:		xbean-spring-pom_xml.patch
Patch10:	xbean-telnet-pom_xml.patch
Patch11:	xbean-tiger-pom_xml.patch

BuildRequires:  jpackage-utils >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.4
BuildRequires:  saxon
BuildRequires:  saxon-scripts
BuildRequires:	cglib

BuildRequires:	ant >= 0:1.6
BuildRequires:	backport-util-concurrent
BuildRequires:	bea-stax-api
BuildRequires:	groovy-jsr
BuildRequires:	jakarta-commons-logging
BuildRequires:	junit
BuildRequires:	mx4j
BuildRequires:	plexus-archiver
BuildRequires:	plexus-utils
BuildRequires:	qdox
BuildRequires:	spring-all

Requires:	ant >= 0:1.6
Requires:	backport-util-concurrent
Requires:	bea-stax-api
Requires:	groovy-jsr
Requires:	jakarta-commons-logging
Requires:	junit
Requires:	mx4j
Requires:	plexus-archiver
Requires:	plexus-utils
Requires:	qdox
Requires:	spring-all

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The goal of XBean project is to created a plugin based 
server analogous to Eclipse being a plugin based IDE. 
XBean will be able to discover, download and install 
server plugins from an Internet based repository. In 
addition, we include support for multiple IoC systems, 
support for running with no IoC system, JMX without JMX 
code, lifecycle and class loader management, and a rock 
solid Spring integration.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
%{summary}.


%prep
%setup -q -n %{name}-%{version}
%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav
%patch6 -b .sav
%patch7 -b .sav
%patch8 -b .sav
%patch9 -b .sav
%patch10 -b .sav
%patch11 -b .sav

%build
cp %{SOURCE3} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

for p in $(find . -name "*.pom"); do
    pushd $(dirname $p)
    bp=`basename $p`
    cp $bp $bp.orig
    /usr/bin/saxon -o $bp $bp.orig /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE2}
    popd
done

for p in $(find . -name "*pom.xml"); do
    pushd $(dirname $p)
    bp=`basename $p`
    cp $bp $bp.orig
    /usr/bin/saxon -o $bp $bp.orig /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE2}
    popd
done

mkdir -p m2_repo/repository/JPP/maven2/default_poms
cp %{SOURCE4} m2_repo/repository/JPP/maven2/default_poms/org.apache-apache.pom
cp pom.xml m2_repo/repository/JPP/maven2/default_poms/JPP.xbean-xbean.pom

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

MVN=/usr/bin/mvn
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/%{repo_dir}
export MAVEN_OPTS="-Dmaven.repo.local=$MAVEN_REPO_LOCAL -Dmaven2.jpp.mode=true -Dmaven.test.failure.ignore=true"
${MVN} -s ${M2SETTINGS} ${MAVEN_OPTS} install javadoc:javadoc


%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/xbean
install -pm 644 maven-xbean-plugin/target/maven-xbean-plugin-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/xbean/maven-xbean-plugin-%{version}.jar
install -pm 644 xbean-classpath/target/xbean-classpath-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/xbean/xbean-classpath-%{version}.jar
install -pm 644 xbean-kernel/target/xbean-kernel-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/xbean/xbean-kernel-%{version}.jar
#install -pm 644 xbean-osgi/target/xbean-osgi-%{version}.jar \
#  $RPM_BUILD_ROOT%{_javadir}/xbean/xbean-osgi-%{version}.jar
install -pm 644 xbean-reflect/target/xbean-reflect-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/xbean/xbean-reflect-%{version}.jar
install -pm 644 xbean-server/target/xbean-server-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/xbean/xbean-server-%{version}.jar
install -pm 644 xbean-spring/target/xbean-spring-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/xbean/xbean-spring-%{version}.jar
install -pm 644 xbean-telnet/target/xbean-telnet-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/xbean/xbean-telnet-%{version}.jar
#install -pm 644 xbean-tiger/target/xbean-tiger-%{version}.jar \
#  $RPM_BUILD_ROOT%{_javadir}/xbean/xbean-tiger-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/xbean && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
cp pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.xbean-xbean.pom
cp maven-xbean-plugin/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.xbean-maven-xbean-plugin.pom
cp xbean-classpath/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.xbean-xbean-classpath.pom
cp xbean-jmx/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.xbean-xbean-jmx.pom
cp xbean-kernel/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.xbean-xbean-kernel.pom
#cp xbean-osgi/pom.xml \
#    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.xbean-xbean-osgi.pom
cp xbean-reflect/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.xbean-xbean-reflect.pom
cp xbean-sca/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.xbean-xbean-sca.pom
cp xbean-server/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.xbean-xbean-server.pom
cp xbean-spring/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.xbean-xbean-spring.pom
cp xbean-telnet/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.xbean-xbean-telnet.pom
#cp xbean-tiger/pom.xml \
#    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.xbean-xbean-tiger.pom


# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/kernel
cp -pr xbean-kernel/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/kernel
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/classpath
cp -pr xbean-classpath/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/classpath
#install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/osgi
#cp -pr xbean-osgi/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/osgi
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/reflect
cp -pr xbean-reflect/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/reflect
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/maven-xbean-plugin
cp -pr maven-xbean-plugin/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/maven-xbean-plugin
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/telnet
cp -pr xbean-telnet/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/telnet
#install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/tiger
#cp -pr xbean-tiger/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/tiger
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/server
cp -pr xbean-server/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/server
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/spring
cp -pr xbean-spring/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/spring
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%{_javadir}/*
%{_datadir}/maven2/poms/JPP.xbean*.pom
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*-%{version}.jar.*
%endif


%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Mon Oct 09 2006 Ralph Apel <r.apel at r-apel.de> - 0:2.3-1jpp
- First JPP-1.7 release
- Add post/postun Requires for javadoc
- Add gcj_support option

